﻿var scorm_obj = {};
var ml = window.ml || {};
ml.scorm = {
    /*
    oid:课件id
    item:内容对象 
        id：当前内容id   (itemId)，
        sid: 记录值索引id    (scormRecordId); 
        src:内容地址    (iframe src属性) 
        uid: 用户标识   (cuser.SID)
        fid：内容展示对象id 如：内嵌 iframe ;
        spath: 路径   (scorm_path)
    */
    current: { oid: null, item: { id: "", src: "", sid: "", uid: "", fid: "", spath: "" }, api: null, init: false, version: null, status: { complete: null, exit: null } },
    ver: "1.0",
    debug: true,
    scormApi: {
        //api1.2
        api: {
            data: scorm_obj,
            lastErrorCode: 0,
            error_matrix: [
                [0, "No error"],
                [101, "General Exception"],
                [201, "Invalid argument error"],
                [202, "Element cannot have children"],
                [203, "Element not an array - Cannot have count"],
                [301, "Not initialized"],
                [401, "Not implemented error"],
                [402, "Invalid set value, element is a keyword"],
                [403, "Element is read only"],
                [404, "Element is write only"],
                [405, "Incorrect Data Type"],
            ],
            LMSInitialize: function (emptyString) {
                if (emptyString == null || emptyString != "") {
                    this.lastErrorCode = 201;
                    return "false";
                }
                this.LMSSetValue("cmi.core.lesson_status", "incomplete");
                ml.scorm.lms_read();

                this.lastErrorCode = 0;
                return "true";
            },
            LMSFinish: function (emptyString) {
                if (emptyString == null || emptyString != "") {
                    this.lastErrorCode = 201;
                    return "false";
                }
                var exit = this.LMSGetValue("cmi.core.exit");
                switch (exit) {
                    case "suspend":
                        this.LMSSetValue("cmi.core.entry", "resume");
                        break;
                    case "":
                    case "time-out":
                    case "logout":
                    default:
                        this.LMSSetValue("cmi.core.entry", "");
                        break;
                }

                return "true";
            },
            LMSGetValue: function (name) {
                var o = scorm_obj[name];
                if (o) {
                    return o;
                } else if (o == "") {
                    delete scorm_obj[name];
                }
                return "";
            },
            LMSGetLastError: function () {
                return this.lastErrorCode;
            },
            LMSGetErrorString: function () {
                var _self = this;
                this.error_matrix.forEach(function (i) {
                    if (_self[i][0] == _self.lastErrorCode) {
                        return _self[i][1];
                    }
                });
                return "";
            },
            LMSSetValue: function (name, value) {
                if (name == "cmi.suspend_data") {
                    //value = "none";
                }
                if (value.indexOf("{") == 0) {
                    value = value.replace(new RegExp("\"", "gm"), "\\\"");
                }
                var o = JSON.parse("{\"" + name + "\":\"" + value + "\"}");
                $.extend(scorm_obj, o);
                return "true";
            }
            , LMSCommit: function () {
                ml.scorm.lms_post();
                return "true";
            },
            LMSGetDiagnostic: function () {
                return "";
            }
        },
        //api2004
        api_1484_11: {
            data: scorm_obj,
            lastErrorCode: 0,
            error_matrix: [
                [0, "No error"],
                [101, "General Exception"],
                [201, "Invalid argument error"],
                [202, "Element cannot have children"],
                [203, "Element not an array - Cannot have count"],
                [301, "Not initialized"],
                [401, "Not implemented error"],
                [402, "Invalid set value, element is a keyword"],
                [403, "Element is read only"],
                [404, "Element is write only"],
                [405, "Incorrect Data Type"],
            ],
            Initialize: function (emptyString) {
                if (emptyString == null || emptyString != "") {
                    this.lastErrorCode = 201;
                    return "false";
                }
                this.LMSSetValue("cmi.core.lesson_status", "incomplete");
                ml.scorm.lms_read();

                this.lastErrorCode = 0;
                return "true";
            },
            Terminate: function (emptyString) {
                if (emptyString == null || emptyString != "") {
                    this.lastErrorCode = 201;
                    return "false";
                }
                var exit = this.GetValue("cmi.exit");
                switch (exit) {
                    case "suspend":
                        this.SetValue("cmi.entry", "resume");
                        break;
                    default:
                        this.SetValue("cmi.entry", "");
                        break;
                }
                if (this.GetValue("cmi.success_status") == "not attempted") {
                    this.SetValue("cmi.success_status", "browsed");
                }
                if (this.GetValue("cmi.completion_status") == "not attempted") {
                    this.SetValue("cmi.completion_status", "browsed");
                }
                if (this.GetValue("cmi.score.scaled") == "0") {
                    this.SetValue("cmi.score.scaled", "1");
                }


                return "true";
            },
            GetValue: function (name) {
                var o = scorm_obj[name];
                if (o) {
                    return o;
                } else if (o == "") {
                    delete scorm_obj[name];
                }
                return null;
            },
            GetLastError: function () {
                return this.lastErrorCode;
            },
            GetErrorString: function () {
                var _self = this;
                this.error_matrix.forEach(function (i) {
                    if (_self[i][0] == _self.lastErrorCode) {
                        return _self[i][1];
                    }
                });
                return "";
            },
            SetValue: function (name, value) {
                if (name == "cmi.suspend_data") {
                    //value = "none";
                }
                if (typeof value == "string" && value.indexOf("{") == 0) {
                    value = value.replace(new RegExp("\"", "gm"), "\\\"");
                }
                var o = JSON.parse("{\"" + name + "\":\"" + value + "\"}");
                $.extend(scorm_obj, o);
                return "true";
            }
            , Commit: function () {
                ml.scorm.lms_post();
                return "true";
            },
            GetDiagnostic: function () {
                return "";
            }
        }
    },
    lms_read: function (rdata) {
        if (this.current.oid) {
            var _self = this;
            if (rdata && rdata.success) {
                //页面加载初始化源数据
                if (rdata.data) {
                    scorm_obj = JSON.parse(rdata.data);
                }
                if (rdata.item) {
                    _self.current.item = $.extend(_self.current.item, rdata.item);
                    var scormdriver_content = document.getElementById(this.current.item.fid).contentWindow.document.getElementById("scormdriver_content");
                    if (scormdriver_content) {
                        var scontent = document.getElementById(this.current.item.fid).contentWindow.document.scormdriver_content
                        if (scontent) {
                            scontent.document.location.href = this.current.item.src;
                        }
                    }
                }
            } else {
                $.post("/lms/read", { id: this.current.oid, version: this.current.version, iid: this.current.item.id, isid: this.current.item.sid, isrc: this.current.item.src, uid: this.current.item.uid, scorm_path: this.current.item.spath }, function (r) {
                    if (r.success) {
                        if (r.data) {
                            scorm_obj = JSON.parse(r.data);
                        }
                        if (r.item) {
                            _self.current.item = $.extend(_self.current.item, r.item);
                        }
                    }
                });
            }
        }
    },
    lms_post: function () {
        if (true) {
            var _self = this;
            var s = JSON.stringify(scorm_obj);
            var iscomplete = this.status() == "completed" ? 1 : 0;
            try {
                var scormdriver_content = document.getElementById(this.current.item.fid).contentWindow.document.getElementById("scormdriver_content");
                if (scormdriver_content) {
                    var src = scormdriver_content.contentWindow.document.location.href; //document.getElementById(this.current.item.fid).contentWindow.document.scormdriver_content.document.location.href;
                    src = src.substring(src.indexOf(this.current.item.spath) + this.current.item.spath.length);
                    this.current.item.src = src;
                }
            } catch (e) {

            }

            $.post("/lms/write", { id: this.current.oid, iid: this.current.item.id, isid: this.current.item.sid, data: s, iscomplete: iscomplete, uid: this.current.item.uid, scorm_path: this.current.item.spath }, function (r) {
                _self._trace(r.msg || r);
            });
        }
    },
    //初始化
    init: function (version, oid, itemFun) {
        switch (version) {
            case "1.2":
                this.current.version = version;
                window.API = this.scormApi.api;
                break;
            case "2004":
                this.current.version = version;
                window.API_1484_11 = this.scormApi.api_1484_11;
                break;
        }
        this.current.oid = oid;
        if (itemFun) {
            this.current.item = $.extend(this.current.item, itemFun());
        }

    },
    fn: {
        formatTime: function (str) {

        }
    },
    //相关wrapper api 方法
    get: function (name) {
        var value = null, api = this.api(), code = 0;
        if (api) {
            switch (this.current.version) {
                case "1.2":
                    value = api.LMSGetValue(name);
                    break;
                case "2004":
                    value = api.GetValue(name);
                    break;
            }
            code = this.code();
            if (value !== "" && code === 0) {
                switch (name) {
                    case "cmi.core.lesson_status":
                    case "cmi.completion_status":
                        this.current.status.complete = value;
                        break;
                    case "cmi.core.exit":
                    case "cmi.exit":
                        this.current.status.exit = value;
                        break;

                }
            } else {
                this._trace("get " + name + " failed.errorCode:" + code);
            }
        }
        this._trace("get " + name + ":" + value);
        return String(value);
    },
    save: function () {
        var success = false, code = 0, api = this.api();
        if (api) {
            switch (this.current.version) {
                case "1.2":
                    success = this._stringToBoolean(api.LMSCommit(""));
                    break;
                case "2004":
                    success = this._stringToBoolean(api.Commit(""));
                    break;
            }
        }
        return success;
    },
    set: function (name, value) {
        var success = false, code = 0, api = this.api();
        if (api) {
            switch (this.current.version) {
                case "1.2":
                    success = this._stringToBoolean(api.LMSSetValue(name, value));
                    break;
                case "2004":
                    success = this._stringToBoolean(api.SetValue(name, value));
                    break;
            }
            code = this.code();
            if (success) {
                if (name === "cmi.core.lesson_status" || name === "cmi.completion_status") {
                    this.current.status.complete = value;
                }
            } else {
                this._trace("set " + name + " failed. errorCode:" + code);
            }
        }
        return success;
    },
    initialize: function () {
        var success = false, code = 0;
        this._trace("initialize called");
        if (!this.current.init) {
            var api = this.api();
            if (api) {
                this.current.init = true;
                switch (this.current.version) {
                    case "1.2": success = this._stringToBoolean(api.LMSInitialize("")); break;
                    case "2004": success = this._stringToBoolean(api.Initialize("")); break;
                }
                code = this.code();
                this.current.init = success;
                if (success) {
                    if (code !== null && code === 0) {
                        this.current.status.complete = this.status();
                        switch (this.current.status.complete) {
                            case "not attempted":
                            case "unknown":
                                this.status("incomplete");
                                break;
                        }
                    }
                } else {
                    this._trace(" initialize failed. errorCode:" + code);
                }
            }
        } else {
            this._trace("already initialize.");
        }
        return success;
    },
    terminate: function () {
        var success = false, api = this.api(), code = 0;
        if (api) {
            if (!this.current.status.exit) {
                if (this.current.status.complete !== "competed" && this.current.status !== "passed") {
                    switch (this.current.version) {
                        case "1.2": success = this.set("cmi.code.exit", "suspend"); break;
                        case "2004": success = this.set("cmi.exit", "suspend"); break;
                    }
                } else {
                    switch (this.current.version) {
                        case "1.2": success = this.set("cmi.code.exit", "logout"); break;
                        case "2004": success = this.set("cmi.exit", "normal"); break;
                    }
                }
            }
            switch (this.current.version) {
                case "1.2": success = this._stringToBoolean(api.LMSFinish("")); break;
                case "2004": success = this._stringToBoolean(api.Terminate("")); break;
            }
            this.current.init = !success;
            code = this.code();
            if (!success) {
                this._trace("terminate failed. errorCode:" + code);
            }
        }
        return success;
    },
    status: function (status) {
        var success = false, isSet = status && status !== null, cmi = "";
        switch (this.current.version) {
            case "1.2":
                cmi = "cmi.core.lesson_status";
                break;
            case "":
                cmi = "cmi.completion_status";
                break;
        }
        if (isSet) {
            success = this.set(cmi, status);
        } else {
            success = this.get(cmi);
        }
        return success;
    },
    code: function () {
        var code = 0, api = this.api();
        if (api) {
            switch (this.current.version) {
                case "1.2":
                    code = parseInt(api.LMSGetLastError(), 10);
                    break;
                case "2004":
                    code = parseInt(api.GetLastError(), 10);
                    break;
            }
        }
        return code;
    },
    api: function () {
        if (this.current.api) {
            return this.current.api;
        }
        var api = null, win = window;
        if (win.parent && win.parent != win) {
            api = this._api(win.parent);
        }
        if (!api && win.top.opener) {
            api = this._api(win.top.opener);
        }
        if (!api) {
            api = this._api(win);
        }
        if (!api) {
            this._trace("can't find the scrom api");
        } else {
            this.current.api = api;
        }
        return api;
    },
    //获取api
    _api: function (win) {
        var api = null, findAttempts = 0, findAttemptLimit = 7;
        while ((!win.API && !win.API_1484_11) && (win.parent) && (win.parent != win) && (findAttempts <= findAttemptLimit)) {
            findAttempts++;
            win = win.parent;
        }
        if (this.current.version) {
            switch (this.current.version) {
                case "2004":
                    if (win.API_1484_11) {
                        api = win.API_1484_11;
                    } else {
                        this._trace("_api" + ": SCORM version 2004 was specified by user, but API_1484_11 cannot be found.");
                    }
                    break;
                case "1.2":
                    if (win.API) {
                        api = win.API;
                    } else {
                        this._trace("_api" + ": SCORM version 1.2 was specified by user, but API cannot be found.");
                    }
                    break;
            }
        } else {
            if (win.API_1484_11) {
                this.current.version = "2004";
                api = win.API_1484_11;
            } else if (win.API) {
                this.current.version = "1.2";
                api = win.API;
            }
        }
        if (api) {
            this._trace("api found. version:" + this.current.version + ". \napi:" + api);
        } else {
            this._trace("not found api. attempts:" + findAttempts + ".limit:" + findAttemptLimit);
        }
        return api;
    },
    _trace: function (msg) {
        if (this.debug) {
            if (window.console && window.console.log(msg)) {
                console.log(msg);
            }
        }
    },
    _stringToBoolean: function (str) {
        if (!str) return false;
        switch (str.toLowerCase()) {
            case "true": case "yes": case "1": return true;
            case "false": case "no": case "0": case null: return false;
            default: return Boolean(str);
        }
    }
};
